diff --git a/game/client/src/main/resources/shaders/photo/inverted/post.vsh b/game/client/src/main/resources/shaders/photo/inverted/post.vsh
index 9c7ba53f5..c95c4842f 100644
--- a/game/client/src/main/resources/shaders/photo/inverted/post.vsh
+++ b/game/client/src/main/resources/shaders/photo/inverted/post.vsh
@@ -1,9 +1,11 @@
-#version 120
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
 
-varying vec2 texcoord;
+out vec2 TexCoords;
 
-void main(){
-	gl_Position = ftransform();
-	
-	texcoord = gl_MultiTexCoord0.xy;
+void main()
+{
+	TexCoords = aTexCoords;
+	gl_Position = vec4(aPos, 0.0, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/outline/post.fsh b/game/client/src/main/resources/shaders/photo/outline/post.fsh
index 378dbf61f..63830932c 100644
--- a/game/client/src/main/resources/shaders/photo/outline/post.fsh
+++ b/game/client/src/main/resources/shaders/photo/outline/post.fsh
@@ -1,4 +1,6 @@
-#version 120
+#version 410
+out vec4 FragColor;
+in vec2 TexCoords;
 
 uniform sampler2D colortex0;
 uniform sampler2D depthtex0;
@@ -7,27 +9,25 @@ uniform float width;
 uniform float height;
 uniform float intensity;
 
-varying vec2 texcoord;
-
 float getDepth(vec2 coord){
-	return texture2D(depthtex0, coord).r;
+	return texture(depthtex0, coord).r;
 }
 
 void main(){
-	vec3 color = texture2D(colortex0, texcoord).rgb;
+	vec3 color = texture(colortex0, TexCoords).rgb;
 	
 	float outline = 0.0;
 	
 	float size = 4.0 * intensity;
 	
-	outline += clamp(getDepth(texcoord) - getDepth(texcoord + vec2(size / width, 0)), 0.0, 1.0);
-	outline += clamp(getDepth(texcoord) - getDepth(texcoord - vec2(size / width, 0)), 0.0, 1.0);
-	outline += clamp(getDepth(texcoord) - getDepth(texcoord + vec2(0, size / height)), 0.0, 1.0);
-	outline += clamp(getDepth(texcoord) - getDepth(texcoord - vec2(0, size / height)), 0.0, 1.0);
+	outline += clamp(getDepth(TexCoords) - getDepth(TexCoords + vec2(size / width, 0)), 0.0, 1.0);
+	outline += clamp(getDepth(TexCoords) - getDepth(TexCoords - vec2(size / width, 0)), 0.0, 1.0);
+	outline += clamp(getDepth(TexCoords) - getDepth(TexCoords + vec2(0, size / height)), 0.0, 1.0);
+	outline += clamp(getDepth(TexCoords) - getDepth(TexCoords - vec2(0, size / height)), 0.0, 1.0);
 	
 	outline = 1.0 - clamp(outline * 512, 0.0, 1.0);
 	
 	color *= outline;
 	
-	gl_FragColor = vec4(color, 1.0);
+	FragColor = vec4(color, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/outline/post.vsh b/game/client/src/main/resources/shaders/photo/outline/post.vsh
index 9c7ba53f5..c95c4842f 100644
--- a/game/client/src/main/resources/shaders/photo/outline/post.vsh
+++ b/game/client/src/main/resources/shaders/photo/outline/post.vsh
@@ -1,9 +1,11 @@
-#version 120
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
 
-varying vec2 texcoord;
+out vec2 TexCoords;
 
-void main(){
-	gl_Position = ftransform();
-	
-	texcoord = gl_MultiTexCoord0.xy;
+void main()
+{
+	TexCoords = aTexCoords;
+	gl_Position = vec4(aPos, 0.0, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/outline2/post.fsh b/game/client/src/main/resources/shaders/photo/outline2/post.fsh
index 24d23552f..0c2f76a45 100644
--- a/game/client/src/main/resources/shaders/photo/outline2/post.fsh
+++ b/game/client/src/main/resources/shaders/photo/outline2/post.fsh
@@ -1,4 +1,6 @@
-#version 120
+#version 410
+out vec4 FragColor;
+in vec2 TexCoords;
 
 uniform sampler2D depthtex0;
 
@@ -6,10 +8,8 @@ uniform float width;
 uniform float height;
 uniform float intensity;
 
-varying vec2 texcoord;
-
 float getDepth(vec2 coord){
-	return texture2D(depthtex0, coord).r;
+	return texture(depthtex0, coord).r;
 }
 
 void main(){
@@ -17,12 +17,12 @@ void main(){
 	
 	float size = 4.0 * intensity;
 	
-	outline += clamp(getDepth(texcoord) - getDepth(texcoord + vec2(size / width, 0)), 0.0, 1.0);
-	outline += clamp(getDepth(texcoord) - getDepth(texcoord - vec2(size / width, 0)), 0.0, 1.0);
-	outline += clamp(getDepth(texcoord) - getDepth(texcoord + vec2(0, size / height)), 0.0, 1.0);
-	outline += clamp(getDepth(texcoord) - getDepth(texcoord - vec2(0, size / height)), 0.0, 1.0);
+	outline += clamp(getDepth(TexCoords) - getDepth(TexCoords + vec2(size / width, 0)), 0.0, 1.0);
+	outline += clamp(getDepth(TexCoords) - getDepth(TexCoords - vec2(size / width, 0)), 0.0, 1.0);
+	outline += clamp(getDepth(TexCoords) - getDepth(TexCoords + vec2(0, size / height)), 0.0, 1.0);
+	outline += clamp(getDepth(TexCoords) - getDepth(TexCoords - vec2(0, size / height)), 0.0, 1.0);
 	
 	outline = 1.0 - clamp(outline * 512, 0.0, 1.0);
 	
-	gl_FragColor = vec4(vec3(outline), 1.0);
+	FragColor = vec4(vec3(outline), 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/outline2/post.vsh b/game/client/src/main/resources/shaders/photo/outline2/post.vsh
index 9c7ba53f5..c95c4842f 100644
--- a/game/client/src/main/resources/shaders/photo/outline2/post.vsh
+++ b/game/client/src/main/resources/shaders/photo/outline2/post.vsh
@@ -1,9 +1,11 @@
-#version 120
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
 
-varying vec2 texcoord;
+out vec2 TexCoords;
 
-void main(){
-	gl_Position = ftransform();
-	
-	texcoord = gl_MultiTexCoord0.xy;
+void main()
+{
+	TexCoords = aTexCoords;
+	gl_Position = vec4(aPos, 0.0, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/sepia/post.fsh b/game/client/src/main/resources/shaders/photo/sepia/post.fsh
index 7a581ef57..048cc98ba 100644
--- a/game/client/src/main/resources/shaders/photo/sepia/post.fsh
+++ b/game/client/src/main/resources/shaders/photo/sepia/post.fsh
@@ -1,11 +1,11 @@
-#version 120
+#version 410
+out vec4 FragColor;
+in vec2 TexCoords;
 
 uniform sampler2D colortex0;
 
 uniform float intensity;
 
-varying vec2 texcoord;
-
 vec3 toSepia(vec3 color)
 {
 	color.r = color.r * 0.393 + color.g * 0.769 + color.b * 0.189;
@@ -17,10 +17,10 @@ vec3 toSepia(vec3 color)
 
 void main()
 {
-	vec3 color = texture2D(colortex0, texcoord).rgb;
+	vec3 color = texture(colortex0, TexCoords).rgb;
 	vec3 sepia = toSepia(color);
 
 	color = mix(color, sepia, intensity);
 
-	gl_FragColor = vec4(color, 1.0);
+	FragColor = vec4(color, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/sepia/post.vsh b/game/client/src/main/resources/shaders/photo/sepia/post.vsh
index 9c7ba53f5..c95c4842f 100644
--- a/game/client/src/main/resources/shaders/photo/sepia/post.vsh
+++ b/game/client/src/main/resources/shaders/photo/sepia/post.vsh
@@ -1,9 +1,11 @@
-#version 120
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
 
-varying vec2 texcoord;
+out vec2 TexCoords;
 
-void main(){
-	gl_Position = ftransform();
-	
-	texcoord = gl_MultiTexCoord0.xy;
+void main()
+{
+	TexCoords = aTexCoords;
+	gl_Position = vec4(aPos, 0.0, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/silhouette/post.fsh b/game/client/src/main/resources/shaders/photo/silhouette/post.fsh
index ef0bcffdc..a739d1a83 100644
--- a/game/client/src/main/resources/shaders/photo/silhouette/post.fsh
+++ b/game/client/src/main/resources/shaders/photo/silhouette/post.fsh
@@ -1,20 +1,20 @@
-#version 120
+#version 410
+out vec4 FragColor;
+in vec2 TexCoords;
 
 uniform sampler2D colortex0;
 uniform sampler2D depthtex0;
 
 uniform float intensity;
 
-varying vec2 texcoord;
-
 void main()
 {
-	vec3 color = texture2D(colortex0, texcoord).rgb;
-	float depth = texture2D(depthtex0, texcoord).r;
+	vec3 color = texture(colortex0, TexCoords).rgb;
+	float depth = texture(depthtex0, TexCoords).r;
 
 	depth = (depth - 0.45) * 10;
 
 	color = mix(color, vec3(depth), intensity);
 
-	gl_FragColor = vec4(color, 1.0);
+	FragColor = vec4(color, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/silhouette/post.vsh b/game/client/src/main/resources/shaders/photo/silhouette/post.vsh
index 9c7ba53f5..c95c4842f 100644
--- a/game/client/src/main/resources/shaders/photo/silhouette/post.vsh
+++ b/game/client/src/main/resources/shaders/photo/silhouette/post.vsh
@@ -1,9 +1,11 @@
-#version 120
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
 
-varying vec2 texcoord;
+out vec2 TexCoords;
 
-void main(){
-	gl_Position = ftransform();
-	
-	texcoord = gl_MultiTexCoord0.xy;
+void main()
+{
+	TexCoords = aTexCoords;
+	gl_Position = vec4(aPos, 0.0, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/tiltshift/post.fsh b/game/client/src/main/resources/shaders/photo/tiltshift/post.fsh
index b0ecd9e97..e119bccc7 100644
--- a/game/client/src/main/resources/shaders/photo/tiltshift/post.fsh
+++ b/game/client/src/main/resources/shaders/photo/tiltshift/post.fsh
@@ -1,4 +1,6 @@
-#version 120
+#version 410
+out vec4 FragColor;
+in vec2 TexCoords;
 
 uniform sampler2D colortex0;
 uniform sampler2D depthtex0;
@@ -7,23 +9,21 @@ uniform float width;
 uniform float height;
 uniform float intensity;
 
-varying vec2 texcoord;
-
 vec3 getBlur(float r){
 	float x, y, xx, yy, rr = r * r, dx, dy, w, w0;
 	w0 = 0.3780 / pow(r, 1.975);
 	vec2 p;
 	vec4 col = vec4(0.0, 0.0, 0.0, 0.0);
-	for (dx = 1.0 / width, x = -r, p.x = (texcoord.x) + (x * dx); x <= r; x++, p.x += dx)
+	for (dx = 1.0 / width, x = -r, p.x = (TexCoords.x) + (x * dx); x <= r; x++, p.x += dx)
 	{
 		xx = x * x;
-		for (dy = 1.0 / height, y = -r, p.y = (texcoord.y) + (y * dy); y <= r; y++, p.y += dy)
+		for (dy = 1.0 / height, y = -r, p.y = (TexCoords.y) + (y * dy); y <= r; y++, p.y += dy)
 		{
 			yy = y * y;
 			if (xx + yy <= rr)
 			{
 				w = w0 * exp((-xx - yy) / (2.0 * rr));
-				col += texture2D(colortex0, p) * w;
+				col += texture(colortex0, p) * w;
 			}
 		}
 	}
@@ -32,9 +32,9 @@ vec3 getBlur(float r){
 
 void main()
 {
-	vec3 color = texture2D(colortex0, texcoord).rgb;
+	vec3 color = texture(colortex0, TexCoords).rgb;
 
-	float blurFactor = clamp(distance(texcoord, vec2(0.5)) * 4 * intensity, 0.0, 1.0);
+	float blurFactor = clamp(distance(TexCoords, vec2(0.5)) * 4 * intensity, 0.0, 1.0);
 	vec3 blur = getBlur(blurFactor * 15);
 
 	//Apply Blur
@@ -46,5 +46,5 @@ void main()
 	//Bloom
 	//color = color * 0.93 + clamp(pow(blur, vec3(2.0)), 0.0, 1.0) * 0.4;
 	
-	gl_FragColor = vec4(color, 1.0);
+	FragColor = vec4(color, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/tiltshift/post.vsh b/game/client/src/main/resources/shaders/photo/tiltshift/post.vsh
index 9c7ba53f5..c95c4842f 100644
--- a/game/client/src/main/resources/shaders/photo/tiltshift/post.vsh
+++ b/game/client/src/main/resources/shaders/photo/tiltshift/post.vsh
@@ -1,9 +1,11 @@
-#version 120
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
 
-varying vec2 texcoord;
+out vec2 TexCoords;
 
-void main(){
-	gl_Position = ftransform();
-	
-	texcoord = gl_MultiTexCoord0.xy;
+void main()
+{
+	TexCoords = aTexCoords;
+	gl_Position = vec4(aPos, 0.0, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/vignette/post.fsh b/game/client/src/main/resources/shaders/photo/vignette/post.fsh
index 9188eb8fe..7ae618a54 100644
--- a/game/client/src/main/resources/shaders/photo/vignette/post.fsh
+++ b/game/client/src/main/resources/shaders/photo/vignette/post.fsh
@@ -1,17 +1,17 @@
-#version 120
+#version 410
+out vec4 FragColor;
+in vec2 TexCoords;
 
 uniform sampler2D colortex0;
 uniform float intensity;
 
-varying vec2 texcoord;
-
 void main(){
-	vec3 color = texture2D(colortex0, texcoord).rgb;
+	vec3 color = texture(colortex0, TexCoords).rgb;
 	
-	float vignette = length(vec2(texcoord - 0.5)) * intensity;
+	float vignette = length(vec2(TexCoords - 0.5)) * intensity;
 	vignette = clamp((vignette - 0.3) * 3, 0.0, 1.0);
 	
 	color = mix(color, vec3(0.0), vignette);
 	
-	gl_FragColor = vec4(color, 1.0);
+	FragColor = vec4(color, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/photo/vignette/post.vsh b/game/client/src/main/resources/shaders/photo/vignette/post.vsh
index 9c7ba53f5..c95c4842f 100644
--- a/game/client/src/main/resources/shaders/photo/vignette/post.vsh
+++ b/game/client/src/main/resources/shaders/photo/vignette/post.vsh
@@ -1,9 +1,11 @@
-#version 120
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
 
-varying vec2 texcoord;
+out vec2 TexCoords;
 
-void main(){
-	gl_Position = ftransform();
-	
-	texcoord = gl_MultiTexCoord0.xy;
+void main()
+{
+	TexCoords = aTexCoords;
+	gl_Position = vec4(aPos, 0.0, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/post/base.fsh b/game/client/src/main/resources/shaders/post/base.fsh
new file mode 100644
index 000000000..1f1cfc31a
--- /dev/null
+++ b/game/client/src/main/resources/shaders/post/base.fsh
@@ -0,0 +1,82 @@
+#version 410
+out vec4 FragColor;
+in vec2 TexCoords;
+
+uniform sampler2D colortex0;
+uniform sampler2D depthtex0;
+
+uniform float gamma;
+
+uniform int cbCorrectionMode;
+
+uniform float width;
+uniform float height;
+
+
+vec3 adjustGamma(vec3 color, float value)
+{
+    return pow(color, vec3(1.0 - value + 0.5));
+}
+
+vec3 cbCorrection(vec3 tex)
+{
+    int mode = cbCorrectionMode;
+    if (mode < 1 || mode > 4) return tex;
+
+    if (mode == 4)//Grayscale
+    {
+        return vec3((tex.r + tex.g + tex.b) / 3.0f);
+    }
+
+    float L = (17.8824 * tex.r) + (43.5161 * tex.g) + (4.11935 * tex.b);
+    float M = (3.45565 * tex.r) + (27.1554 * tex.g) + (3.86714 * tex.b);
+    float S = (0.0299566 * tex.r) + (0.184309 * tex.g) + (1.46709 * tex.b);
+
+    float l, m, s;
+    if (mode == 1)//Protanopia
+    {
+        l = 0.0 * L + 2.02344 * M + -2.52581 * S;
+        m = 0.0 * L + 1.0 * M + 0.0 * S;
+        s = 0.0 * L + 0.0 * M + 1.0 * S;
+    }
+
+    if (mode == 2)//Deuteranopia
+    {
+        l = 1.0 * L + 0.0 * M + 0.0 * S;
+        m = 0.494207 * L + 0.0 * M + 1.24827 * S;
+        s = 0.0 * L + 0.0 * M + 1.0 * S;
+    }
+
+    if (mode == 3)//Tritanopia
+    {
+        l = 1.0 * L + 0.0 * M + 0.0 * S;
+        m = 0.0 * L + 1.0 * M + 0.0 * S;
+        s = -0.395913 * L + 0.801109 * M + 0.0 * S;
+    }
+
+    vec3 error;
+    error.r = (0.0809444479 * l) + (-0.130504409 * m) + (0.116721066 * s);
+    error.g = (-0.0102485335 * l) + (0.0540193266 * m) + (-0.113614708 * s);
+    error.b = (-0.000365296938 * l) + (-0.00412161469 * m) + (0.693511405 * s);
+    vec3 diff = tex - error;
+    vec3 correction;
+    correction.r = 0.0;
+    correction.g =  (diff.r * 0.7) + (diff.g * 1.0);
+    correction.b =  (diff.r * 0.7) + (diff.b * 1.0);
+    correction = tex + correction;
+
+    return correction;
+}
+
+void main()
+{
+    vec3 color = vec3(0.0);
+
+    color = texture(colortex0, TexCoords).rgb;
+
+    color = cbCorrection(color);
+
+    color = adjustGamma(color, gamma);
+
+    FragColor = vec4(color, 1.0);
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/post/base.vsh b/game/client/src/main/resources/shaders/post/base.vsh
new file mode 100644
index 000000000..c95c4842f
--- /dev/null
+++ b/game/client/src/main/resources/shaders/post/base.vsh
@@ -0,0 +1,11 @@
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
+
+out vec2 TexCoords;
+
+void main()
+{
+	TexCoords = aTexCoords;
+	gl_Position = vec4(aPos, 0.0, 1.0);
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/post.fsh b/game/client/src/main/resources/shaders/post/post.fsh
similarity index 79%
rename from game/client/src/main/resources/shaders/post.fsh
rename to game/client/src/main/resources/shaders/post/post.fsh
index 6b9aa03e7..180f9656c 100644
--- a/game/client/src/main/resources/shaders/post.fsh
+++ b/game/client/src/main/resources/shaders/post/post.fsh
@@ -1,4 +1,8 @@
-#version 120
+#version 410
+
+out vec4 FragColor;
+
+in vec2 TexCoords;
 
 uniform sampler2D colortex0;
 uniform sampler2D depthtex0;
@@ -23,8 +27,6 @@ uniform float width;
 uniform float height;
 uniform float frameTimeCounter;
 
-varying vec2 texcoord;
-
 #define PI 3.14159
 
 // FXAA defines
@@ -35,11 +37,11 @@ float FXAA_SPAN_MAX = 8.0f * fxaa;
 vec4 applyFXAA(vec2 fragCoord, sampler2D tex, vec2 uViewportSize) {
     vec4 color;
     vec2 inverseVP = vec2(1.0 / uViewportSize.x, 1.0 / uViewportSize.y);
-    vec3 rgbNW = texture2D(tex, (fragCoord + vec2(-1.0, -1.0)) * inverseVP).xyz;
-    vec3 rgbNE = texture2D(tex, (fragCoord + vec2(1.0, -1.0)) * inverseVP).xyz;
-    vec3 rgbSW = texture2D(tex, (fragCoord + vec2(-1.0, 1.0)) * inverseVP).xyz;
-    vec3 rgbSE = texture2D(tex, (fragCoord + vec2(1.0, 1.0)) * inverseVP).xyz;
-    vec3 rgbM  = texture2D(tex, fragCoord  * inverseVP).xyz;
+    vec3 rgbNW = texture(tex, (fragCoord + vec2(-1.0, -1.0)) * inverseVP).xyz;
+    vec3 rgbNE = texture(tex, (fragCoord + vec2(1.0, -1.0)) * inverseVP).xyz;
+    vec3 rgbSW = texture(tex, (fragCoord + vec2(-1.0, 1.0)) * inverseVP).xyz;
+    vec3 rgbSE = texture(tex, (fragCoord + vec2(1.0, 1.0)) * inverseVP).xyz;
+    vec3 rgbM  = texture(tex, fragCoord  * inverseVP).xyz;
     vec3 luma = vec3(0.299, 0.587, 0.114);
     float lumaNW = dot(rgbNW, luma);
     float lumaNE = dot(rgbNE, luma);
@@ -62,11 +64,11 @@ vec4 applyFXAA(vec2 fragCoord, sampler2D tex, vec2 uViewportSize) {
     dir * rcpDirMin)) * inverseVP;
 
     vec3 rgbA = 0.5 * (
-    texture2D(tex, fragCoord * inverseVP + dir * (1.0 / 3.0 - 0.5)).xyz +
-    texture2D(tex, fragCoord * inverseVP + dir * (2.0 / 3.0 - 0.5)).xyz);
+    texture(tex, fragCoord * inverseVP + dir * (1.0 / 3.0 - 0.5)).xyz +
+    texture(tex, fragCoord * inverseVP + dir * (2.0 / 3.0 - 0.5)).xyz);
     vec3 rgbB = rgbA * 0.5 + 0.25 * (
-    texture2D(tex, fragCoord * inverseVP + dir * -0.5).xyz +
-    texture2D(tex, fragCoord * inverseVP + dir * 0.5).xyz);
+    texture(tex, fragCoord * inverseVP + dir * -0.5).xyz +
+    texture(tex, fragCoord * inverseVP + dir * 0.5).xyz);
 
     float lumaB = dot(rgbB, luma);
     if ((lumaB < lumaMin) || (lumaB > lumaMax))
@@ -115,7 +117,7 @@ void Bloom(inout vec3 color) {
 			
 			float strength = dist;
 			
-			blur += pow(texture2D(colortex0, texcoord.xy + offset).rgb, vec3(2.2f)) * strength;
+			blur += pow(texture(colortex0, TexCoords + offset).rgb, vec3(2.2f)) * strength;
 			allStrengths += strength;
 		}
 	}
@@ -127,7 +129,7 @@ void Bloom(inout vec3 color) {
 }
 
 void HeatHaze(inout vec2 coord, float amount) {
-	float depth = texture2D(depthtex0, coord.xy).r;
+	float depth = texture(depthtex0, coord.xy).r;
 	float strength = pow(depth, 500);
 	strength = (strength - 0.16) * 2.0f;
 	strength = clamp(strength, 0.0f, 1.0f) * amount;
@@ -153,22 +155,22 @@ vec3 colorEffects(vec3 tex) {
 
 void main() {
     vec3 color = vec3(0.0);
-	vec2 coord = texcoord;
-	
+	vec2 coord = TexCoords;
+
 	if(heatHaze > 0) {
 		HeatHaze(coord, heatHaze);
 	}
-	
+
     if (fxaa > 0.01) {
         color = applyFXAA(vec2(coord.x * width, coord.y * height), colortex0, vec2(width, height)).rgb;
     } else {
-        color = texture2D(colortex0, coord.xy).rgb;
+        color = texture(colortex0, coord.xy).rgb;
     }
-	
+
 	if(bloom > 0) {
 		Bloom(color);
 	}
-	
+
     // Perform color correction
     color = adjustBrightness(color, brightness);
     color = adjustContrast(color, contrast);
@@ -176,6 +178,10 @@ void main() {
     color = adjustSaturation(color, saturation);
     color = adjustColor(color, rMod, gMod, bMod);
     color = colorEffects(color);
-	
-    gl_FragColor = vec4(color, 1.0);
+
+    FragColor = vec4(color, 1.0);
+
+//    float depth = texture(depthtex0, TexCoords).r;
+//    depth = pow(depth, 1000);
+//    FragColor = vec4(depth, depth, depth, 1.0);
 }
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/post/post.vsh b/game/client/src/main/resources/shaders/post/post.vsh
new file mode 100644
index 000000000..1ae551a3a
--- /dev/null
+++ b/game/client/src/main/resources/shaders/post/post.vsh
@@ -0,0 +1,11 @@
+#version 410 core
+layout (location = 0) in vec2 aPos;
+layout (location = 1) in vec2 aTexCoords;
+
+out vec2 TexCoords;
+
+void main()
+{
+    TexCoords = aTexCoords;
+    gl_Position = vec4(aPos, 0.0, 1.0);
+}
\ No newline at end of file
diff --git a/game/client/src/main/resources/shaders/showdepth.fsh b/game/client/src/main/resources/shaders/post/showdepth.fsh
similarity index 76%
rename from game/client/src/main/resources/shaders/showdepth.fsh
rename to game/client/src/main/resources/shaders/post/showdepth.fsh
index 1b8d1ff11..bc1360925 100644
--- a/game/client/src/main/resources/shaders/showdepth.fsh
+++ b/game/client/src/main/resources/shaders/post/showdepth.fsh
@@ -5,7 +5,7 @@ uniform sampler2D depthtex0;
 varying vec2 texcoord;
 
 void main(){
-	float depth = texture2D(depthtex0, texcoord).r;
+	float depth = texture(depthtex0, texcoord).r;
 	
 	depth = pow(depth, 1000);
 	
diff --git a/game/client/src/main/resources/shaders/world.fsh b/game/client/src/main/resources/shaders/world.fsh
new file mode 100644
index 000000000..9d9f5081b
--- /dev/null
+++ b/game/client/src/main/resources/shaders/world.fsh
@@ -0,0 +1,66 @@
+#version 410 core
+
+out vec4 FragColor;
+
+in vec4 Color;
+in vec2 TexCoord;
+in vec2 LightMapCoord;
+in float Distance;
+in vec3 Light;
+
+uniform vec4 ucolor;
+
+uniform vec4 ufogColor;
+uniform int ufogMode;
+uniform float ufogStart;
+uniform float ufogEnd;
+uniform float ufogDensity;
+
+uniform sampler2D texture0;
+uniform sampler2D texture1;
+
+// Taken from https://github.com/hughsk/glsl-fog
+float fogFactorLinear() {
+    return 1.0 - clamp(((ufogEnd - (Distance)) / (ufogEnd - ufogStart)), 0.0, 1.0);
+}
+
+float fogFactorExp() {
+    return 1.0 - clamp(exp(-ufogDensity * (Distance)), 0.0, 1.0);
+}
+
+float fogFactorExp2() {
+    float LOG2 = -1.442695;
+    float d = ufogDensity * (Distance);
+    return 1.0 - clamp(exp2(d * d * LOG2), 0.0, 1.0);
+}
+
+
+vec4 computeFog(vec4 color) {
+    float f = 0;
+    if (ufogMode == 0) { // Linear
+        f = fogFactorLinear();
+    }
+    else if (ufogMode == 1) { // EXP
+        f = fogFactorExp();
+    }
+    else if (ufogMode == 2) { // EXP2
+        f = fogFactorExp2();
+    }
+    return vec4(mix(color.rgb, ufogColor.rgb, f), color.a);
+}
+
+void main() {
+    vec4 lightColor = texture(texture1, LightMapCoord);
+    vec4 texColor = texture(texture0, TexCoord);
+
+    vec4 oColor = texColor * lightColor * Color * ucolor;
+    vec4 litColor = vec4(oColor.rgb * clamp(Light, 0, 1), oColor.a);
+
+    vec4 fColor = computeFog(litColor);
+
+
+    FragColor = fColor;
+    if (FragColor.a < 0.1f) {
+        discard;
+    }
+}
diff --git a/game/client/src/main/resources/shaders/world.vsh b/game/client/src/main/resources/shaders/world.vsh
new file mode 100644
index 000000000..97d6d3f8e
--- /dev/null
+++ b/game/client/src/main/resources/shaders/world.vsh
@@ -0,0 +1,38 @@
+#version 410 core
+layout (location = 0) in vec3 aPos;
+layout (location = 1) in vec4 aColor;
+layout (location = 2) in vec2 aUV;
+layout (location = 3) in vec2 aLightmap;
+layout (location = 4) in vec3 aNormal;
+
+out vec4 Color;
+out vec2 TexCoord;
+out vec2 LightMapCoord;
+out float Distance;
+out vec3 Light;
+
+uniform mat4 normalTransform;
+uniform vec4 lightModelAmbient;
+uniform vec4 lightSourcePosition[];
+uniform vec4 lightSourceDiffuse[];
+
+uniform mat4 model;
+uniform mat4 view;
+uniform mat4 projection;
+
+void main() {
+    vec4 p = vec4(aPos, 1);
+    gl_Position = projection * view * model * p;
+
+    TexCoord = aUV;
+    Color = aColor;
+    LightMapCoord = aLightmap;
+
+    // Used for the radial fog in shader
+    Distance = length((view * model * p).xyz);
+
+    vec4 norm = normalize(normalTransform * model * vec4(aNormal, 0));
+    float dir1 = max(0.0f, dot(norm, lightSourcePosition[0]));
+    float dir2 = max(0.0f, dot(norm, lightSourcePosition[1]));
+    Light = (lightModelAmbient + lightSourceDiffuse[0] * (dir1 + dir2)).xyz;
+}
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
index 7e529741b..e9be8f585 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
@@ -227,7 +227,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
             }
         }
 
-        return new Bounds(axis, new TilePos(tilePos), maxBoundA, maxBoundY);
+        return new Bounds(axis, new TilePos(p), maxBoundA, maxBoundY);
     }
 
     public boolean tryToCreatePortal(@NotNull World world, @NotNull TilePosc tilePos, @Nullable DyeColor color) {
@@ -240,7 +240,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         world.noNeighborUpdate = true;
         switch (bounds.axis) {
             case X: {
-                TilePos p = new TilePos(0, 0, 0);
+                TilePos p = new TilePos();
                 for (int ra = 1; ra < bounds.maxBoundA; ra++) {
                     for (int ry = 1; ry < bounds.maxBoundB; ry++) {
                         p.x = bounds.pos.x + ra;
@@ -260,7 +260,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
                 break;
             }
             case Z: {
-                TilePos p = new TilePos(0, 0, 0);
+                TilePos p = new TilePos();
                 for (int ra = 1; ra < bounds.maxBoundA; ra++) {
                     for (int ry = 1; ry < bounds.maxBoundB; ry++) {
                         p.x = bounds.pos.x;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index b59005a58..058afc505 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -10,10 +10,12 @@ import net.minecraft.core.entity.animal.MobPig;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.block.piston.BlockLogicPistonHead;
 import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -1312,65 +1314,49 @@ public abstract class Entity
     public void killed(Mob mob) {
     }
 
-    protected boolean checkInTile(double d, double d1, double d2) {
-        int i = MathHelper.floor(d);
-        int j = MathHelper.floor(d1);
-        int k = MathHelper.floor(d2);
-        double d3 = d - (double) i;
-        double d4 = d1 - (double) j;
-        double d5 = d2 - (double) k;
-        if (this.world.isBlockNormalCube(i, j, k)) {
-            boolean flag = !this.world.isBlockNormalCube(i - 1, j, k);
-            boolean flag1 = !this.world.isBlockNormalCube(i + 1, j, k);
-            boolean flag2 = !this.world.isBlockNormalCube(i, j - 1, k);
-            boolean flag3 = !this.world.isBlockNormalCube(i, j + 1, k);
-            boolean flag4 = !this.world.isBlockNormalCube(i, j, k - 1);
-            boolean flag5 = !this.world.isBlockNormalCube(i, j, k + 1);
-            byte byte0 = -1;
-            double d6 = 9999D;
-            if (flag && d3 < d6) {
-                d6 = d3;
-                byte0 = 0;
+    protected boolean checkAndPushInTile(double x, double y, double z) {
+        TilePosc tilePos = new TilePos(x, y, z);
+        TilePos queryPos = new TilePos();
+        double depthX = x - (double) tilePos.x();
+        double depthY = y - (double) tilePos.y();
+        double depthZ = z - (double) tilePos.z();
+        if (this.world.isBlockNormalCube(tilePos)) {
+            Direction direction = Direction.NONE;
+            double minDepth = Double.MAX_VALUE;
+            if (depthX < minDepth && !this.world.isBlockNormalCube(tilePos.west(queryPos))) {
+                minDepth = depthX;
+                direction = Direction.WEST;
             }
-            if (flag1 && 1.0D - d3 < d6) {
-                d6 = 1.0D - d3;
-                byte0 = 1;
+            if (1.0D - depthX < minDepth && !this.world.isBlockNormalCube(tilePos.east(queryPos))) {
+                minDepth = 1.0D - depthX;
+                direction = Direction.EAST;
             }
-            if (flag2 && d4 < d6) {
-                d6 = d4;
-                byte0 = 2;
+            if (depthY < minDepth && !this.world.isBlockNormalCube(tilePos.down(queryPos))) {
+                minDepth = depthY;
+                direction = Direction.DOWN;
             }
-            if (flag3 && 1.0D - d4 < d6) {
-                d6 = 1.0D - d4;
-                byte0 = 3;
+            if (1.0D - depthY < minDepth && !this.world.isBlockNormalCube(tilePos.up(queryPos))) {
+                minDepth = 1.0D - depthY;
+                direction = Direction.UP;
             }
-            if (flag4 && d5 < d6) {
-                d6 = d5;
-                byte0 = 4;
+            if (depthZ < minDepth && !this.world.isBlockNormalCube(tilePos.north(queryPos))) {
+                minDepth = depthZ;
+                direction = Direction.NORTH;
             }
-            if (flag5 && 1.0D - d5 < d6) {
-                double d7 = 1.0D - d5;
-                byte0 = 5;
+            if (1.0D - depthZ < minDepth && !this.world.isBlockNormalCube(tilePos.south(queryPos))) {
+//                minDepth = 1.0D - depthZ;
+                direction = Direction.SOUTH;
             }
-            float f = this.random.nextFloat() * 0.2F + 0.1F;
-            if (byte0 == 0) {
-                this.xd = -f;
-            }
-            if (byte0 == 1) {
-                this.xd = f;
-            }
-            if (byte0 == 2) {
-                this.yd = -f;
-            }
-            if (byte0 == 3) {
-                this.yd = f;
-            }
-            if (byte0 == 4) {
-                this.zd = -f;
-            }
-            if (byte0 == 5) {
-                this.zd = f;
+            float pushOut = this.random.nextFloat() * 0.2F + 0.1F;
+            switch (direction) {
+                case WEST -> this.xd = -pushOut;
+                case EAST -> this.xd = pushOut;
+                case DOWN -> this.yd = -pushOut;
+                case UP -> this.yd = pushOut;
+                case NORTH -> this.zd = -pushOut;
+                case SOUTH -> this.zd = pushOut;
             }
+            return true;
         }
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
index c28403b42..6837107e2 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -102,7 +102,7 @@ public class EntityItem extends Entity
             this.world.playSoundAtEntity(null, this, "random.fizz", 0.4F, 2.0F + this.random.nextFloat() * 0.4F);
         }
 
-        checkInTile(this.x, (this.bb.minY + this.bb.maxY) / 2D, this.z);
+        checkAndPushInTile(this.x, (this.bb.minY + this.bb.maxY) / 2D, this.z);
         move(this.xd, this.yd, this.zd);
         
         if(!this.world.isClientSide) {
